C++代码信息

运行结果
教程手册
代码仓库
极速运行
交互输入
极速运行模式,不支持键盘输入语句但是拥有更高的运行速度,输出简洁明了 。 点击编辑器上方的运行按钮即刻体验吧。
以下是用户最新保存的代码
继承和组合混搭情况下的类构造和析构 发布于:2020-11-24 14:41 const修饰 发布于:2020-11-23 15:15 地图着色 给已知的地图(比如中国地图)着色,请设计地图着色软件,对个区域(各省)进行着色,要求相邻区域(省)所使用的颜色不同,并保证使用的颜色最少(最少是四色)。 发布于:2020-11-21 12:48 运动会排程算法 在安排运动会比赛日程时,需要考虑如何安排比赛项目,才能使同一运动员参加的不同项目不在同一日进行,同时又使比赛总的日程最短。 发布于:2020-11-21 12:19 continue 语句组成 发布于:2020-11-20 11:16 对输入英文字母原样输出 发布于:2020-11-20 11:00 跳出循环代码 发布于:2020-11-20 10:47 字符串类 (运算符重载 =,[],==,!=,<<,>>) 发布于:2020-11-20 16:45 const修饰指针 发布于:2020-11-19 19:18 数组类 运算符重载(=,[],==,!=,<<,>>) 发布于:2020-11-19 10:57 c++用类建立猜数字小游戏 发布于:2020-11-17 15:31 打印数组 (数组类案例) 发布于:2020-11-17 16:12 前置++,--,和后置++,--运算符重载 发布于:2020-11-16 17:11 运算符重载(用友元函数实现私有属性) 发布于:2020-11-16 16:36 c++ 的demo 体验 发布于:2020-11-16 14:49 排序算法之插入排序 发布于:2020-11-16 16:54 判断两圆是否相交( 全局函数改为类成员函数) 发布于:2020-11-13 15:31 排序算法之希尔排序 发布于:2020-11-12 17:43 2种访问静态成员变量方法 发布于:2020-11-12 14:48 构造和析构调用顺序 发布于:2020-11-11 16:53 求最大值并输出 发布于:2020-11-10 13:00 C++prime5 1.4.1 发布于:2020-11-09 18:03 C++prime5 P10 发布于:2020-11-09 17:55 判断两圆是否相交 发布于:2020-11-13 15:29 原型模式之孙悟空: 发布于:2020-11-06 19:24 原型模式示例 发布于:2020-11-06 15:29 判断点是否在圆内 发布于:2020-11-04 16:38 中缀表达式转化为后缀表达式 发布于:2020-10-30 19:03 中缀表达式转化为后缀表达式 发布于:2020-10-30 19:03 中缀表达式转化为后缀表达式 发布于:2020-10-30 18:57 约瑟夫环 c++实现 发布于:2020-10-28 19:22 定义一个单链表并赋值 发布于:2020-10-23 17:25 找幸运数.cpp 发布于:2020-10-22 17:19 数据结构相关代码 发布于:2020-10-21 21:45 从键盘输入一串字符,以回车键结束,分别统计输入的字母、数字和其它字符的个数 发布于:2020-10-15 17:41 从键盘输入一串字符,以回车键结束,分别统计输入的字母、数字和其它字符的个数 发布于:2020-10-15 17:24 c++学习笔记——类与对象 发布于:2020-10-07 16:57 dfs "ABC"全排列 发布于:2020-09-26 00:47 C++冒泡排序 发布于:2020-09-25 21:42 List8Simaliar JuZhen 发布于:2020-09-24 11:30 List8Simaliar JuZhen 发布于:2020-09-24 11:29 List8Simaliar JuZhen 发布于:2020-09-23 19:27 C++ Heapify 发布于:2020-09-23 00:32 C++实现简单选择排序 发布于:2020-09-22 20:19 C++实现快速排序 发布于:2020-09-22 19:58 测试用cpp 发布于:2020-09-19 20:35 保存了,结成取最右 发布于:2020-09-17 19:28 计算回国日期。 发布于:2020-09-16 19:00 类Point 私有和公有代码 发布于:2020-09-15 23:26 C/C++ 字符串匹配算法时间复杂度比较 发布于:2020-09-16 11:30 [更多]
显示目录

异常处理

C++ 异常处理

异常是程序在执行期间产生的问题。C++ 异常是指在程序运行时发生的特殊情况,比如尝试除以零的操作。

异常提供了一种转移程序控制权的方式。C++ 异常处理涉及到三个关键字:try、catch、throw

  • throw: 当问题出现时,程序会抛出一个异常。这是通过使用 throw 关键字来完成的。
  • catch: 在您想要处理问题的地方,通过异常处理程序捕获异常。catch 关键字用于捕获异常。
  • try: try 块中的代码标识将被激活的特定异常。它后面通常跟着一个或多个 catch 块。

如果有一个块抛出一个异常,捕获异常的方法会使用 trycatch 关键字。try 块中放置可能抛出异常的代码,try 块中的代码被称为保护代码。使用 try/catch 语句的语法如下所示:

try
{
   // 保护代码
}catch( ExceptionName e1 )
{
   // catch 块
}catch( ExceptionName e2 )
{
   // catch 块
}catch( ExceptionName eN )
{
   // catch 块
}

如果 try 块在不同的情境下会抛出不同的异常,这个时候可以尝试罗列多个 catch 语句,用于捕获不同类型的异常。

抛出异常

您可以使用 throw 语句在代码块中的任何地方抛出异常。throw 语句的操作数可以是任意的表达式,表达式的结果的类型决定了抛出的异常的类型。

以下是尝试除以零时抛出异常的实例:

double division(int a, int b)
{
   if( b == 0 )
   {
      throw "Division by zero condition!";
   }
   return (a/b);
}

捕获异常

catch 块跟在 try 块后面,用于捕获异常。您可以指定想要捕捉的异常类型,这是由 catch 关键字后的括号内的异常声明决定的。

try
{
   // 保护代码
}catch( ExceptionName e )
{
  // 处理 ExceptionName 异常的代码
}

上面的代码会捕获一个类型为 ExceptionName 的异常。如果您想让 catch 块能够处理 try 块抛出的任何类型的异常,则必须在异常声明的括号内使用省略号 ...,如下所示:

try
{
   // 保护代码
}catch(...)
{
  // 能处理任何异常的代码
}

下面是一个实例,抛出一个除以零的异常,并在 catch 块中捕获该异常。

#include <iostream>
using namespace std;

double division(int a, int b) {
   if( b == 0 )
   {
      throw "Division by zero condition!";
   }
   return (a/b);
}

int main () {
   int x = 50;
   int y = 0;
   double z = 0;

   try {
     z = division(x, y);
     cout << z << endl;
   }catch (const char* msg) {
     cerr << msg << endl;
   }

   return 0;
}

由于我们抛出了一个类型为 const char* 的异常,因此,当捕获该异常时,我们必须在 catch 块中使用 const char*。当上面的代码被编译和执行时,它会产生下列结果:

Division by zero condition!

C++ 标准的异常

C++ 提供了一系列标准的异常,定义在 <exception> 中,我们可以在程序中使用这些标准的异常。它们是以父子类层次结构组织起来的,如下所示:

C++ 异常的层次结构

下表是对上面层次结构中出现的每个异常的说明:

异常 描述
std::exception 该异常是所有标准 C++ 异常的父类。
std::bad_alloc 该异常可以通过 new 抛出。
std::bad_cast 该异常可以通过 dynamic_cast 抛出。
std::bad_exception 这在处理 C++ 程序中无法预期的异常时非常有用。
std::bad_typeid 该异常可以通过 typeid 抛出。
std::logic_error 理论上可以通过读取代码来检测到的异常。
std::domain_error 当使用了一个无效的数学域时,会抛出该异常。
std::invalid_argument 当使用了无效的参数时,会抛出该异常。
std::length_error 当创建了太长的 std::string 时,会抛出该异常。
std::out_of_range 该异常可以通过方法抛出,例如 std::vector 和 std::bitset<>::operator
std::runtime_error 理论上不可以通过读取代码来检测到的异常。
std::overflow_error 当发生数学上溢时,会抛出该异常。
std::range_error 当尝试存储超出范围的值时,会抛出该异常。
std::underflow_error 当发生数学下溢时,会抛出该异常。

定义新的异常

您可以通过继承和重载 exception 类来定义新的异常。下面的实例演示了如何使用 std::exception 类来实现自己的异常:

#include <iostream>
#include <exception>
using namespace std;

struct MyException : public exception
{
  const char * what () const throw () {
    return "C++ Exception";
  }
};

int main() {
  try
  {
    throw MyException();
  }
  catch(MyException& e)
  {
    std::cout << "MyException caught" << std::endl;
    std::cout << e.what() << std::endl;
  }
  catch(std::exception& e)
  {
    //其他的错误
  }
}

这将产生以下结果:

MyException caught
C++ Exception

在这里,what() 是异常类提供的一个公共方法,它已被所有子异常类重载。这将返回异常产生的原因。

由JSRUN为你提供的C++在线工具
        JSRUN提供的C++在线运行,C++ 在线编译工具,基于linux操作系统环境提供线上编译和线上运行,具有运行快速,运行结果与常用开发、生产环境保持一致的特点。

title

使用此草稿 删除草稿

皮肤:

运行模式:

嵌入代码 iframe嵌入: